/***************************************************************************
 *  This file is automatically generated by gen-get-set.  Be sure to keep
 *  track of any manual changes.
 *
 *  These generated functions are not expected to be perfect.  Check and
 *  edit as needed before adding to your code.
 ***************************************************************************/

#include <string.h>
#include <ctype.h>
#include <xtend/string.h>      // strlcpy() on Linux
#include "gff.h"


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of sequence member in a bl_gff_t
 *      structure. Use this function to set an element of the array
 *      sequence in a bl_gff_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_SEQUENCE_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_sequence_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the sequence array
 *      new_sequence_element    The new value for sequence[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      size_t          c;
 *      char            new_sequence_element;
 *
 *      if ( bl_gff_set_sequence(&bl_gff, c, new_sequence_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_SEQUENCE_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_sequence_ae(bl_gff_t *bl_gff_ptr, size_t c, char new_sequence_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_sequence_element) && (new_sequence_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->sequence[c] = new_sequence_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for sequence member in a bl_gff_t structure.
 *      Use this function to set sequence in a bl_gff_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_sequence to ->sequence.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_SEQUENCE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_sequence is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_sequence    The new value for sequence
 *      array_size      Size of the sequence array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char            new_sequence;
 *      size_t          array_size;
 *
 *      if ( bl_gff_set_sequence(&bl_gff, new_sequence, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_SEQUENCE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_sequence_cpy(bl_gff_t *bl_gff_ptr, char new_sequence[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_sequence == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_gff_ptr->sequence, new_sequence, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of source member in a bl_gff_t
 *      structure. Use this function to set an element of the array
 *      source in a bl_gff_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_SOURCE_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_source_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the source array
 *      new_source_element The new value for source[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      size_t          c;
 *      char            new_source_element;
 *
 *      if ( bl_gff_set_source(&bl_gff, c, new_source_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_SOURCE_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_source_ae(bl_gff_t *bl_gff_ptr, size_t c, char new_source_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_source_element) && (new_source_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->source[c] = new_source_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for source member in a bl_gff_t structure.
 *      Use this function to set source in a bl_gff_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_source to ->source.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_SOURCE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_source is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_source      The new value for source
 *      array_size      Size of the source array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char            new_source;
 *      size_t          array_size;
 *
 *      if ( bl_gff_set_source(&bl_gff, new_source, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_SOURCE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_source_cpy(bl_gff_t *bl_gff_ptr, char new_source[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_source == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_gff_ptr->source, new_source, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of feature member in a bl_gff_t
 *      structure. Use this function to set an element of the array
 *      feature in a bl_gff_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_FEATURE_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_feature_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the feature array
 *      new_feature_element     The new value for feature[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      size_t          c;
 *      char            new_feature_element;
 *
 *      if ( bl_gff_set_feature(&bl_gff, c, new_feature_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_FEATURE_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_feature_ae(bl_gff_t *bl_gff_ptr, size_t c, char new_feature_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_feature_element) && (new_feature_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->feature[c] = new_feature_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for feature member in a bl_gff_t structure.
 *      Use this function to set feature in a bl_gff_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_feature to ->feature.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_FEATURE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_feature is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_feature     The new value for feature
 *      array_size      Size of the feature array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char            new_feature;
 *      size_t          array_size;
 *
 *      if ( bl_gff_set_feature(&bl_gff, new_feature, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_FEATURE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_feature_cpy(bl_gff_t *bl_gff_ptr, char new_feature[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_feature == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_gff_ptr->feature, new_feature, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for start member in a bl_gff_t structure.
 *      Use this function to set start in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      start is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_start is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_start       The new value for start
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      uint64_t        new_start;
 *
 *      if ( bl_gff_set_start(&bl_gff, new_start) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_start(bl_gff_t *bl_gff_ptr, uint64_t new_start)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->start = new_start;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for end member in a bl_gff_t structure.
 *      Use this function to set end in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      end is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_end is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_end         The new value for end
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      uint64_t        new_end;
 *
 *      if ( bl_gff_set_end(&bl_gff, new_end) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_end(bl_gff_t *bl_gff_ptr, uint64_t new_end)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->end = new_end;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for score member in a bl_gff_t structure.
 *      Use this function to set score in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      score is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_score is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_score       The new value for score
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      double          new_score;
 *
 *      if ( bl_gff_set_score(&bl_gff, new_score) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_score(bl_gff_t *bl_gff_ptr, double new_score)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->score = new_score;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for strand member in a bl_gff_t structure.
 *      Use this function to set strand in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      strand is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_strand is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_strand      The new value for strand
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char            new_strand;
 *
 *      if ( bl_gff_set_strand(&bl_gff, new_strand) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_strand(bl_gff_t *bl_gff_ptr, char new_strand)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->strand = new_strand;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for phase member in a bl_gff_t structure.
 *      Use this function to set phase in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      phase is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_phase is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_phase       The new value for phase
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char            new_phase;
 *
 *      if ( bl_gff_set_phase(&bl_gff, new_phase) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_phase(bl_gff_t *bl_gff_ptr, char new_phase)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->phase = new_phase;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for attributes member in a bl_gff_t structure.
 *      Use this function to set attributes in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      attributes is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_attributes is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_attributes  The new value for attributes
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char *          new_attributes;
 *
 *      if ( bl_gff_set_attributes(&bl_gff, new_attributes) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_attributes(bl_gff_t *bl_gff_ptr, char * new_attributes)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_attributes == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->attributes = new_attributes;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of attributes member in a bl_gff_t
 *      structure. Use this function to set an element of the array
 *      attributes in a bl_gff_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_ATTRIBUTES_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_attributes_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the attributes array
 *      new_attributes_element  The new value for attributes[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      size_t          c;
 *      char *          new_attributes_element;
 *
 *      if ( bl_gff_set_attributes(&bl_gff, c, new_attributes_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_ATTRIBUTES_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_attributes_ae(bl_gff_t *bl_gff_ptr, size_t c, char  new_attributes_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_attributes_element) && (new_attributes_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->attributes[c] = new_attributes_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for attributes member in a bl_gff_t structure.
 *      Use this function to set attributes in a bl_gff_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_attributes to ->attributes.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_ATTRIBUTES(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_attributes is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_attributes  The new value for attributes
 *      array_size      Size of the attributes array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char *          new_attributes;
 *      size_t          array_size;
 *
 *      if ( bl_gff_set_attributes(&bl_gff, new_attributes, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_ATTRIBUTES(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_attributes_cpy(bl_gff_t *bl_gff_ptr, char * new_attributes, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_attributes == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_gff_ptr->attributes, new_attributes, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for feature_id member in a bl_gff_t structure.
 *      Use this function to set feature_id in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      feature_id is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_feature_id is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_feature_id  The new value for feature_id
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char *          new_feature_id;
 *
 *      if ( bl_gff_set_feature_id(&bl_gff, new_feature_id) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_feature_id(bl_gff_t *bl_gff_ptr, char * new_feature_id)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_feature_id == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->feature_id = new_feature_id;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of feature_id member in a bl_gff_t
 *      structure. Use this function to set an element of the array
 *      feature_id in a bl_gff_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_FEATURE_ID_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_feature_id_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the feature_id array
 *      new_feature_id_element  The new value for feature_id[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      size_t          c;
 *      char *          new_feature_id_element;
 *
 *      if ( bl_gff_set_feature_id(&bl_gff, c, new_feature_id_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_FEATURE_ID_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_feature_id_ae(bl_gff_t *bl_gff_ptr, size_t c, char  new_feature_id_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_feature_id_element) && (new_feature_id_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->feature_id[c] = new_feature_id_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for feature_id member in a bl_gff_t structure.
 *      Use this function to set feature_id in a bl_gff_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_feature_id to ->feature_id.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_FEATURE_ID(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_feature_id is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_feature_id  The new value for feature_id
 *      array_size      Size of the feature_id array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char *          new_feature_id;
 *      size_t          array_size;
 *
 *      if ( bl_gff_set_feature_id(&bl_gff, new_feature_id, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_FEATURE_ID(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_feature_id_cpy(bl_gff_t *bl_gff_ptr, char * new_feature_id, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_feature_id == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_gff_ptr->feature_id, new_feature_id, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for gene_name member in a bl_gff_t structure.
 *      Use this function to set gene_name in a bl_gff_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      gene_name is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_gene_name is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_gene_name   The new value for gene_name
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char *          new_gene_name;
 *
 *      if ( bl_gff_set_gene_name(&bl_gff, new_gene_name) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_gene_name(bl_gff_t *bl_gff_ptr, char * new_gene_name)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_gene_name == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->gene_name = new_gene_name;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of gene_name member in a bl_gff_t
 *      structure. Use this function to set an element of the array
 *      gene_name in a bl_gff_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_GENE_NAME_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_gene_name_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the gene_name array
 *      new_gene_name_element   The new value for gene_name[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      size_t          c;
 *      char *          new_gene_name_element;
 *
 *      if ( bl_gff_set_gene_name(&bl_gff, c, new_gene_name_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_GENE_NAME_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_gene_name_ae(bl_gff_t *bl_gff_ptr, size_t c, char  new_gene_name_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_gene_name_element) && (new_gene_name_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_gff_ptr->gene_name[c] = new_gene_name_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/gff.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for gene_name member in a bl_gff_t structure.
 *      Use this function to set gene_name in a bl_gff_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_gene_name to ->gene_name.
 *
 *      Note that there is an equivalent macro BL_GFF_SET_GENE_NAME(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_gene_name is guaranteed by other means.
 *
 *  Arguments:
 *      bl_gff_ptr      Pointer to the bl_bed_t structure to set
 *      new_gene_name   The new value for gene_name
 *      array_size      Size of the gene_name array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_gff_t        bl_gff;
 *      char *          new_gene_name;
 *      size_t          array_size;
 *
 *      if ( bl_gff_set_gene_name(&bl_gff, new_gene_name, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_GFF_SET_GENE_NAME(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from gff.h
 ***************************************************************************/

int     bl_gff_set_gene_name_cpy(bl_gff_t *bl_gff_ptr, char * new_gene_name, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_gene_name == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_gff_ptr->gene_name, new_gene_name, array_size);
	return BL_DATA_OK;
    }
}
