/***************************************************************************
 *  This file is automatically generated by gen-get-set.  Be sure to keep
 *  track of any manual changes.
 *
 *  These generated functions are not expected to be perfect.  Check and
 *  edit as needed before adding to your code.
 ***************************************************************************/

#include <string.h>
#include <ctype.h>
#include <xtend/string.h>      // strlcpy() on Linux
#include "vcf.h"


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of chrom member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      chrom in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_CHROM_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_chrom_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the chrom array
 *      new_chrom_element The new value for chrom[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char            new_chrom_element;
 *
 *      if ( bl_vcf_set_chrom(&bl_vcf, c, new_chrom_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_CHROM_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_chrom_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char new_chrom_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_chrom_element) && (new_chrom_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->chrom[c] = new_chrom_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for chrom member in a bl_vcf_t structure.
 *      Use this function to set chrom in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_chrom to ->chrom.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_CHROM(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_chrom is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_chrom       The new value for chrom
 *      array_size      Size of the chrom array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char            new_chrom;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_chrom(&bl_vcf, new_chrom, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_CHROM(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_chrom_cpy(bl_vcf_t *bl_vcf_ptr, char new_chrom[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_chrom == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->chrom, new_chrom, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of id member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      id in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_ID_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_id_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the id array
 *      new_id_element  The new value for id[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char            new_id_element;
 *
 *      if ( bl_vcf_set_id(&bl_vcf, c, new_id_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_ID_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_id_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char new_id_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_id_element) && (new_id_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->id[c] = new_id_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for id member in a bl_vcf_t structure.
 *      Use this function to set id in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_id to ->id.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_ID(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_id is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_id          The new value for id
 *      array_size      Size of the id array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char            new_id;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_id(&bl_vcf, new_id, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_ID(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_id_cpy(bl_vcf_t *bl_vcf_ptr, char new_id[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_id == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->id, new_id, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of ref member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      ref in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_REF_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_ref_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the ref array
 *      new_ref_element The new value for ref[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char            new_ref_element;
 *
 *      if ( bl_vcf_set_ref(&bl_vcf, c, new_ref_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_REF_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_ref_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char new_ref_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_ref_element) && (new_ref_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->ref[c] = new_ref_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for ref member in a bl_vcf_t structure.
 *      Use this function to set ref in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_ref to ->ref.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_REF(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_ref is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_ref         The new value for ref
 *      array_size      Size of the ref array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char            new_ref;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_ref(&bl_vcf, new_ref, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_REF(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_ref_cpy(bl_vcf_t *bl_vcf_ptr, char new_ref[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_ref == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->ref, new_ref, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of alt member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      alt in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_ALT_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_alt_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the alt array
 *      new_alt_element The new value for alt[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char            new_alt_element;
 *
 *      if ( bl_vcf_set_alt(&bl_vcf, c, new_alt_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_ALT_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_alt_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char new_alt_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_alt_element) && (new_alt_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->alt[c] = new_alt_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for alt member in a bl_vcf_t structure.
 *      Use this function to set alt in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_alt to ->alt.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_ALT(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_alt is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_alt         The new value for alt
 *      array_size      Size of the alt array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char            new_alt;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_alt(&bl_vcf, new_alt, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_ALT(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_alt_cpy(bl_vcf_t *bl_vcf_ptr, char new_alt[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_alt == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->alt, new_alt, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of qual member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      qual in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_QUAL_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_qual_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the qual array
 *      new_qual_element The new value for qual[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char            new_qual_element;
 *
 *      if ( bl_vcf_set_qual(&bl_vcf, c, new_qual_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_QUAL_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_qual_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char new_qual_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_qual_element) && (new_qual_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->qual[c] = new_qual_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for qual member in a bl_vcf_t structure.
 *      Use this function to set qual in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_qual to ->qual.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_QUAL(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_qual is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_qual        The new value for qual
 *      array_size      Size of the qual array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char            new_qual;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_qual(&bl_vcf, new_qual, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_QUAL(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_qual_cpy(bl_vcf_t *bl_vcf_ptr, char new_qual[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_qual == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->qual, new_qual, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of filter member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      filter in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_FILTER_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_filter_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the filter array
 *      new_filter_element The new value for filter[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char            new_filter_element;
 *
 *      if ( bl_vcf_set_filter(&bl_vcf, c, new_filter_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_FILTER_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_filter_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char new_filter_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( !isprint(new_filter_element) && (new_filter_element != '\0') )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->filter[c] = new_filter_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for filter member in a bl_vcf_t structure.
 *      Use this function to set filter in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_filter to ->filter.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_FILTER(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_filter is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_filter      The new value for filter
 *      array_size      Size of the filter array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char            new_filter;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_filter(&bl_vcf, new_filter, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_FILTER(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_filter_cpy(bl_vcf_t *bl_vcf_ptr, char new_filter[], size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_filter == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->filter, new_filter, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for info member in a bl_vcf_t structure.
 *      Use this function to set info in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      info is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_info is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_info        The new value for info
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char *          new_info;
 *
 *      if ( bl_vcf_set_info(&bl_vcf, new_info) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_info(bl_vcf_t *bl_vcf_ptr, char * new_info)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_info == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->info = new_info;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of info member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      info in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_INFO_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_info_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the info array
 *      new_info_element The new value for info[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char *          new_info_element;
 *
 *      if ( bl_vcf_set_info(&bl_vcf, c, new_info_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_INFO_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_info_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char  new_info_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->info[c] = new_info_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for info member in a bl_vcf_t structure.
 *      Use this function to set info in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_info to ->info.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_INFO(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_info is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_info        The new value for info
 *      array_size      Size of the info array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char *          new_info;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_info(&bl_vcf, new_info, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_INFO(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_info_cpy(bl_vcf_t *bl_vcf_ptr, char * new_info, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_info == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->info, new_info, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for format member in a bl_vcf_t structure.
 *      Use this function to set format in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      format is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_format is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_format      The new value for format
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char *          new_format;
 *
 *      if ( bl_vcf_set_format(&bl_vcf, new_format) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_format(bl_vcf_t *bl_vcf_ptr, char * new_format)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_format == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->format = new_format;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of format member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      format in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_FORMAT_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_format_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the format array
 *      new_format_element The new value for format[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char *          new_format_element;
 *
 *      if ( bl_vcf_set_format(&bl_vcf, c, new_format_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_FORMAT_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_format_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char  new_format_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->format[c] = new_format_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for format member in a bl_vcf_t structure.
 *      Use this function to set format in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_format to ->format.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_FORMAT(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_format is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_format      The new value for format
 *      array_size      Size of the format array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char *          new_format;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_format(&bl_vcf, new_format, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_FORMAT(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_format_cpy(bl_vcf_t *bl_vcf_ptr, char * new_format, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_format == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->format, new_format, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for single_sample member in a bl_vcf_t structure.
 *      Use this function to set single_sample in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      single_sample is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_single_sample is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_single_sample The new value for single_sample
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char *          new_single_sample;
 *
 *      if ( bl_vcf_set_single_sample(&bl_vcf, new_single_sample) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_single_sample(bl_vcf_t *bl_vcf_ptr, char * new_single_sample)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_single_sample == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->single_sample = new_single_sample;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of single_sample member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      single_sample in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_SINGLE_SAMPLE_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_single_sample_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the single_sample array
 *      new_single_sample_element The new value for single_sample[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char *          new_single_sample_element;
 *
 *      if ( bl_vcf_set_single_sample(&bl_vcf, c, new_single_sample_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_SINGLE_SAMPLE_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_single_sample_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char  new_single_sample_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->single_sample[c] = new_single_sample_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for single_sample member in a bl_vcf_t structure.
 *      Use this function to set single_sample in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_single_sample to ->single_sample.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_SINGLE_SAMPLE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_single_sample is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_single_sample The new value for single_sample
 *      array_size      Size of the single_sample array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char *          new_single_sample;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_single_sample(&bl_vcf, new_single_sample, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_SINGLE_SAMPLE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_single_sample_cpy(bl_vcf_t *bl_vcf_ptr, char * new_single_sample, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_single_sample == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_vcf_ptr->single_sample, new_single_sample, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for pos member in a bl_vcf_t structure.
 *      Use this function to set pos in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      pos is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_pos is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_pos         The new value for pos
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      uint64_t        new_pos;
 *
 *      if ( bl_vcf_set_pos(&bl_vcf, new_pos) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_pos(bl_vcf_t *bl_vcf_ptr, uint64_t new_pos)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->pos = new_pos;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for info_len member in a bl_vcf_t structure.
 *      Use this function to set info_len in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      info_len is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_info_len is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_info_len    The new value for info_len
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          new_info_len;
 *
 *      if ( bl_vcf_set_info_len(&bl_vcf, new_info_len) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_info_len(bl_vcf_t *bl_vcf_ptr, size_t new_info_len)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->info_len = new_info_len;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for info_max member in a bl_vcf_t structure.
 *      Use this function to set info_max in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      info_max is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_info_max is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_info_max    The new value for info_max
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          new_info_max;
 *
 *      if ( bl_vcf_set_info_max(&bl_vcf, new_info_max) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_info_max(bl_vcf_t *bl_vcf_ptr, size_t new_info_max)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->info_max = new_info_max;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for format_max member in a bl_vcf_t structure.
 *      Use this function to set format_max in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      format_max is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_format_max is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_format_max  The new value for format_max
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          new_format_max;
 *
 *      if ( bl_vcf_set_format_max(&bl_vcf, new_format_max) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_format_max(bl_vcf_t *bl_vcf_ptr, size_t new_format_max)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->format_max = new_format_max;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for sample_max member in a bl_vcf_t structure.
 *      Use this function to set sample_max in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      sample_max is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_sample_max is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_sample_max  The new value for sample_max
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          new_sample_max;
 *
 *      if ( bl_vcf_set_sample_max(&bl_vcf, new_sample_max) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_sample_max(bl_vcf_t *bl_vcf_ptr, size_t new_sample_max)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->sample_max = new_sample_max;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for ref_count member in a bl_vcf_t structure.
 *      Use this function to set ref_count in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      ref_count is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_ref_count is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_ref_count   The new value for ref_count
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      unsigned        new_ref_count;
 *
 *      if ( bl_vcf_set_ref_count(&bl_vcf, new_ref_count) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_ref_count(bl_vcf_t *bl_vcf_ptr, unsigned new_ref_count)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->ref_count = new_ref_count;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for alt_count member in a bl_vcf_t structure.
 *      Use this function to set alt_count in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      alt_count is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_alt_count is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_alt_count   The new value for alt_count
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      unsigned        new_alt_count;
 *
 *      if ( bl_vcf_set_alt_count(&bl_vcf, new_alt_count) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_alt_count(bl_vcf_t *bl_vcf_ptr, unsigned new_alt_count)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->alt_count = new_alt_count;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for other_count member in a bl_vcf_t structure.
 *      Use this function to set other_count in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      other_count is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_other_count is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_other_count The new value for other_count
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      unsigned        new_other_count;
 *
 *      if ( bl_vcf_set_other_count(&bl_vcf, new_other_count) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_other_count(bl_vcf_t *bl_vcf_ptr, unsigned new_other_count)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->other_count = new_other_count;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for multi_samples member in a bl_vcf_t structure.
 *      Use this function to set multi_samples in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      multi_samples is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_multi_samples is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_multi_samples The new value for multi_samples
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char **         new_multi_samples;
 *
 *      if ( bl_vcf_set_multi_samples(&bl_vcf, new_multi_samples) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_multi_samples(bl_vcf_t *bl_vcf_ptr, char ** new_multi_samples)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_multi_samples == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->multi_samples = new_multi_samples;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of multi_samples member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      multi_samples in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_MULTI_SAMPLES_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_multi_samples_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the multi_samples array
 *      new_multi_samples_element The new value for multi_samples[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      char **         new_multi_samples_element;
 *
 *      if ( bl_vcf_set_multi_samples(&bl_vcf, c, new_multi_samples_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_MULTI_SAMPLES_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_multi_samples_ae(bl_vcf_t *bl_vcf_ptr, size_t c, char * new_multi_samples_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_multi_samples_element == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->multi_samples[c] = new_multi_samples_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for multi_samples member in a bl_vcf_t structure.
 *      Use this function to set multi_samples in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_multi_samples to ->multi_samples.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_MULTI_SAMPLES(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_multi_samples is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_multi_samples The new value for multi_samples
 *      array_size      Size of the multi_samples array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      char **         new_multi_samples;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_multi_samples(&bl_vcf, new_multi_samples, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_MULTI_SAMPLES(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_multi_samples_cpy(bl_vcf_t *bl_vcf_ptr, char ** new_multi_samples, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_multi_samples == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	{
	    size_t  c;
	    
	    // FIXME: Assuming all elements should be copied
	    for (c = 0; c < array_size; ++c)
		bl_vcf_ptr->multi_samples[c] = new_multi_samples[c];
	}
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for phreds member in a bl_vcf_t structure.
 *      Use this function to set phreds in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      phreds is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_phreds is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_phreds      The new value for phreds
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      unsigned char * new_phreds;
 *
 *      if ( bl_vcf_set_phreds(&bl_vcf, new_phreds) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_phreds(bl_vcf_t *bl_vcf_ptr, unsigned char * new_phreds)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_phreds == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->phreds = new_phreds;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of phreds member in a bl_vcf_t
 *      structure. Use this function to set an element of the array
 *      phreds in a bl_vcf_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_PHREDS_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_phreds_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      c               Subscript to the phreds array
 *      new_phreds_element The new value for phreds[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          c;
 *      unsigned char * new_phreds_element;
 *
 *      if ( bl_vcf_set_phreds(&bl_vcf, c, new_phreds_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_PHREDS_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_phreds_ae(bl_vcf_t *bl_vcf_ptr, size_t c, unsigned char  new_phreds_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->phreds[c] = new_phreds_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for phreds member in a bl_vcf_t structure.
 *      Use this function to set phreds in a bl_vcf_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_phreds to ->phreds.
 *
 *      Note that there is an equivalent macro BL_VCF_SET_PHREDS(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_phreds is guaranteed by other means.
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_phreds      The new value for phreds
 *      array_size      Size of the phreds array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      unsigned char * new_phreds;
 *      size_t          array_size;
 *
 *      if ( bl_vcf_set_phreds(&bl_vcf, new_phreds, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_VCF_SET_PHREDS(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_phreds_cpy(bl_vcf_t *bl_vcf_ptr, unsigned char * new_phreds, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_phreds == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	{
	    size_t  c;
	    
	    // FIXME: Assuming all elements should be copied
	    for (c = 0; c < array_size; ++c)
		bl_vcf_ptr->phreds[c] = new_phreds[c];
	}
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for phred_count member in a bl_vcf_t structure.
 *      Use this function to set phred_count in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      phred_count is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_phred_count is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_phred_count The new value for phred_count
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          new_phred_count;
 *
 *      if ( bl_vcf_set_phred_count(&bl_vcf, new_phred_count) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_phred_count(bl_vcf_t *bl_vcf_ptr, size_t new_phred_count)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->phred_count = new_phred_count;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/vcf.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for phred_buff_size member in a bl_vcf_t structure.
 *      Use this function to set phred_buff_size in a bl_vcf_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      phred_buff_size is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_phred_buff_size is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_vcf_ptr      Pointer to the bl_bed_t structure to set
 *      new_phred_buff_size The new value for phred_buff_size
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_vcf_t        bl_vcf;
 *      size_t          new_phred_buff_size;
 *
 *      if ( bl_vcf_set_phred_buff_size(&bl_vcf, new_phred_buff_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-25  gen-get-set Auto-generated from vcf.h
 ***************************************************************************/

int     bl_vcf_set_phred_buff_size(bl_vcf_t *bl_vcf_ptr, size_t new_phred_buff_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_vcf_ptr->phred_buff_size = new_phred_buff_size;
	return BL_DATA_OK;
    }
}
