/***************************************************************************
 *  This file is automatically generated by gen-get-set.  Be sure to keep
 *  track of any manual changes.
 *
 *  These generated functions are not expected to be perfect.  Check and
 *  edit as needed before adding to your code.
 ***************************************************************************/

#include <string.h>
#include <ctype.h>
#include <xtend/string.h>      // strlcpy() on Linux
#include "fasta.h"


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for desc member in a bl_fasta_t structure.
 *      Use this function to set desc in a bl_fasta_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      desc is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_desc is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      new_desc        The new value for desc
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      char *          new_desc;
 *
 *      if ( bl_fasta_set_desc(&bl_fasta, new_desc) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_desc(bl_fasta_t *bl_fasta_ptr, char * new_desc)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_desc == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->desc = new_desc;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of desc member in a bl_fasta_t
 *      structure. Use this function to set an element of the array
 *      desc in a bl_fasta_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_FASTA_SET_DESC_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_desc_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_fasta_ptr        Pointer to the bl_bed_t structure to set
 *      c                   Subscript to the desc array
 *      new_desc_element    The new value for desc[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      size_t          c;
 *      char *          new_desc_element;
 *
 *      if ( bl_fasta_set_desc(&bl_fasta, c, new_desc_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_FASTA_SET_DESC_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_desc_ae(bl_fasta_t *bl_fasta_ptr, size_t c, char  new_desc_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->desc[c] = new_desc_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for desc member in a bl_fasta_t structure.
 *      Use this function to set desc in a bl_fasta_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_desc to ->desc.
 *
 *      Note that there is an equivalent macro BL_FASTA_SET_DESC(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_desc is guaranteed by other means.
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      new_desc        The new value for desc
 *      array_size      Size of the desc array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      char *          new_desc;
 *      size_t          array_size;
 *
 *      if ( bl_fasta_set_desc(&bl_fasta, new_desc, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_FASTA_SET_DESC(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_desc_cpy(bl_fasta_t *bl_fasta_ptr, char * new_desc, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_desc == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_fasta_ptr->desc, new_desc, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for seq member in a bl_fasta_t structure.
 *      Use this function to set seq in a bl_fasta_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      seq is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_seq is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      new_seq         The new value for seq
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      char *          new_seq;
 *
 *      if ( bl_fasta_set_seq(&bl_fasta, new_seq) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_seq(bl_fasta_t *bl_fasta_ptr, char * new_seq)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_seq == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->seq = new_seq;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for an array element of seq member in a bl_fasta_t
 *      structure. Use this function to set an element of the array
 *      seq in a bl_fasta_t variable from non-member functions.
 *
 *      Note that there is an equivalent macro BL_FASTA_SET_SEQ_AE(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_seq_element is guaranteed by other means.
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      c               Subscript to the seq array
 *      new_seq_element The new value for seq[c]
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      size_t          c;
 *      char *          new_seq_element;
 *
 *      if ( bl_fasta_set_seq(&bl_fasta, c, new_seq_element) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_FASTA_SET_SEQ_AE(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_seq_ae(bl_fasta_t *bl_fasta_ptr, size_t c, char  new_seq_element)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->seq[c] = new_seq_element;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for seq member in a bl_fasta_t structure.
 *      Use this function to set seq in a bl_fasta_t variable
 *      from non-member functions.  This function copies the array pointed to
 *      by new_seq to ->seq.
 *
 *      Note that there is an equivalent macro BL_FASTA_SET_SEQ(), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_seq is guaranteed by other means.
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      new_seq         The new value for seq
 *      array_size      Size of the seq array.
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      char *          new_seq;
 *      size_t          array_size;
 *
 *      if ( bl_fasta_set_seq(&bl_fasta, new_seq, array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      BL_FASTA_SET_SEQ(3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_seq_cpy(bl_fasta_t *bl_fasta_ptr, char * new_seq, size_t array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( new_seq == NULL )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	// FIXME: Assuming char array is a null-terminated string
	strlcpy(bl_fasta_ptr->seq, new_seq, array_size);
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for desc_array_size member in a bl_fasta_t structure.
 *      Use this function to set desc_array_size in a bl_fasta_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      desc_array_size is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_desc_array_size is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_fasta_ptr        Pointer to the bl_bed_t structure to set
 *      new_desc_array_size The new value for desc_array_size
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      size_t          new_desc_array_size;
 *
 *      if ( bl_fasta_set_desc_array_size(&bl_fasta, new_desc_array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_desc_array_size(bl_fasta_t *bl_fasta_ptr, size_t new_desc_array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->desc_array_size = new_desc_array_size;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for seq_array_size member in a bl_fasta_t structure.
 *      Use this function to set seq_array_size in a bl_fasta_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      seq_array_size is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_seq_array_size is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_fasta_ptr        Pointer to the bl_bed_t structure to set
 *      new_seq_array_size  The new value for seq_array_size
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      size_t          new_seq_array_size;
 *
 *      if ( bl_fasta_set_seq_array_size(&bl_fasta, new_seq_array_size) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_seq_array_size(bl_fasta_t *bl_fasta_ptr, size_t new_seq_array_size)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->seq_array_size = new_seq_array_size;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for desc_len member in a bl_fasta_t structure.
 *      Use this function to set desc_len in a bl_fasta_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      desc_len is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_desc_len is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      new_desc_len    The new value for desc_len
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      size_t          new_desc_len;
 *
 *      if ( bl_fasta_set_desc_len(&bl_fasta, new_desc_len) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_desc_len(bl_fasta_t *bl_fasta_ptr, size_t new_desc_len)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->desc_len = new_desc_len;
	return BL_DATA_OK;
    }
}


/***************************************************************************
 *  Library:
 *      #include <biolibc/fasta.h>
 *      -lbiolibc -lxtend
 *
 *  Description:
 *      Mutator for seq_len member in a bl_fasta_t structure.
 *      Use this function to set seq_len in a bl_fasta_t variable
 *      from non-member functions.  This function performs a direct
 *      assignment for scalar or pointer structure members.  If
 *      seq_len is a pointer, data previously pointed to should
 *      generally be freed before calling this function to avoid memory
 *      leaks.
 *
 *      Note that there is an equivalent macro (), which performs
 *      this function with no data verification or function call overhead.
 *      Use the macro version to maximize performance where the validity
 *      of new_seq_len is guaranteed by other means.
 *      
 *
 *  Arguments:
 *      bl_fasta_ptr    Pointer to the bl_bed_t structure to set
 *      new_seq_len     The new value for seq_len
 *
 *  Returns:
 *      BL_DATA_OK if the new value is acceptable and assigned
 *      BL_DATA_OUT_OF_RANGE otherwise
 *
 *  Examples:
 *      bl_fasta_t      bl_fasta;
 *      size_t          new_seq_len;
 *
 *      if ( bl_fasta_set_seq_len(&bl_fasta, new_seq_len) == BL_DATA_OK )
 *      {
 *      }
 *
 *  See also:
 *      (3)
 *
 *  History: 
 *  Date        Name        Modification
 *  2021-07-27  gen-get-set Auto-generated from fasta.h
 ***************************************************************************/

int     bl_fasta_set_seq_len(bl_fasta_t *bl_fasta_ptr, size_t new_seq_len)

{
    /* FIXME: Replace this with a proper sanity check */
    if ( 0 )
	return BL_DATA_OUT_OF_RANGE;
    else
    {
	bl_fasta_ptr->seq_len = new_seq_len;
	return BL_DATA_OK;
    }
}
